﻿using System;
using System.Collections.Generic;
using System.Data;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Xml.Linq;
using Microsoft.VisualStudio.Tools.Applications.Runtime;
using Excel = Microsoft.Office.Interop.Excel;
using Office = Microsoft.Office.Core;
using System.Runtime.InteropServices;
using Microsoft.VisualBasic;

namespace VSTO_C_example
{
    public partial class Tabelle1
    {

        [StructLayout(LayoutKind.Sequential)]
        public struct Nag_Spline
        {

            public int n;

            public IntPtr lamda;

            public IntPtr c;

            public int init1;

            public int init2;

        };

        [StructLayout(LayoutKind.Sequential)]
        public struct NagError
        {

            public int code;    // int

            public int print;   // Boolean



            [MarshalAs(UnmanagedType.ByValArray, SizeConst = 512)]

            public char[] char_array;    // char [NAG_ERROR_BUF_LEN]   

            public IntPtr handler;   // NAG_ERRHAN

            public int errnum;      // Integer

            public int iflag;   // Integer

            public int ival;    // Integer

        }

        [DllImport("CLW3209DA_nag")]
        public static extern void e01bac(int m, double[] x, double[] y,

                                         ref Nag_Spline spline, ref NagError fail);

        [DllImport("CLW3209DA_nag")]

        public static extern void e02bbc(double x, ref double s, ref Nag_Spline spline,

                                         ref NagError fail);

        [DllImport("CLW3209DA_nag")]

        public static extern void e01bec(int n, double[] x, double[] f, double[] d,

                                         ref NagError fail);

        [DllImport("CLW3209DA_nag")]

        public static extern void e01bfc(int n, double[] x, double[] f, double[] d,

                                         int m, double[] px, double[] pf, ref NagError fail);

        [DllImport("CLW3209DA_nag")]

        public static extern void e02adc(int m, int kplus1, int tda, double[] x, double[] y,

                                         double[] w, double[,] a, double[] s, ref NagError fail);

        [DllImport("CLW3209DA_nag")]

        public static extern void e02aec(int nplus1, double[] a, double xcap, ref double p,

                                         ref NagError fail);

        [DllImport("CLW3209DA_nag")]

        public static extern void e02bac(int m, double[] x, double[] y, double[] w, ref double ss,
                                         ref Nag_Spline spline, ref NagError fail);


        private void Tabelle1_Startup(object sender, System.EventArgs e)
        {
        }

        private void Tabelle1_Shutdown(object sender, System.EventArgs e)
        {
        }

        #region Vom VSTO-Designer generierter Code

        /// <summary>
        /// Erforderliche Methode für die Designerunterstützung.
        /// Der Inhalt der Methode darf nicht mit dem Code-Editor geändert werden.
        /// </summary>
        private void InternalStartup()
        {
            this.button1.Click += new System.EventHandler(this.button1_Click);
            this.comboBox1.SelectedIndexChanged += new System.EventHandler(this.comboBox1_SelectedIndexChanged);
            this.comboBox2.SelectedIndexChanged += new System.EventHandler(this.comboBox2_SelectedIndexChanged);
            this.Shutdown += new System.EventHandler(this.Tabelle1_Shutdown);
            this.Startup += new System.EventHandler(this.Tabelle1_Startup);

        }

        #endregion

        private void comboBox1_SelectedIndexChanged(object sender, EventArgs e)
        {
            double[] X1 = { 0.0, 1.0, 2.0, 3.0, 4.0, 5.0, 6.0, 7.0, 8.0, 9.0, 10.0, 11.0, 12.0, 13.0 };
            double[] Y1 = { 0, 0.841470985, 0.909297427, 0.141120008, -0.756802495, -0.958924275, -0.279415498, 0.656986599, 0.989358247, 0.412118485, -0.544021111, -0.999990207, -0.536572918, 0.420167037 };
            double[] X2 = { 0, 400, 800, 1200, 1600, 2000, 2400, 2800, 3200, 3600, 4000, 4400, 4800, 5200, 5600, 6000 };
            double[] Y2 = { 0, -4600, -5200, -4700, -5200, -5600, -5500, -4200, -2500, -4900, -5500, -6000, -5800, -5100, -4200, 0 };
            double[] Y3 = { 0.644, 0.722, 0.838, 0.949, 0.852, 0.739, 0.646, 0.457, 0.452, 0.555, 0.644, 0.763, 0.963, 1.068, 0.976, 1.076, 0.786, 0.679, 0.578, 0.683, 0.694, 0.699, 0.71, 0.73, 0.763, 0.812, 0.907, 1.044, 1.336, 1.881, 2.169, 2.075, 1.598, 1.211, 0.916, 0.746, 0.672, 0.627, 0.615, 0.607, 0.606, 0.609, 0.603, 0.601, 0.603, 0.601, 0.611, 0.601, 0.608 };
            double[] X3 = new double[Y3.Length];
            for (int i = 0; i < Y3.Length; i++)
            {
                X3[i] = i + 1;
            }

            get_Range("S1", "T32000").ClearContents();
            get_Range("U1", "V32000").ClearContents();
            get_Range("A2", "C32000").ClearContents();
            get_Range("D10", "E32000").ClearContents();


            //switch between the different data series. save data into the excel sheet
            int ind = comboBox1.SelectedIndex;
            switch (ind)
            {
                case 0:

                    for (int i = 0; i < X1.Length; i++)
                    {
                        Cells[i + 2, 1] = X1[i];
                        Cells[i + 2, 2] = Y1[i];
                    }
                    break;

                case 1:

                    for (int i = 0; i < X2.Length; i++)
                    {
                        Cells[i + 2, 1] = X2[i];
                        Cells[i + 2, 2] = Y2[i];
                    }
                    break;

                case 2:

                    for (int i = 0; i < X3.Length; i++)
                    {
                        Cells[i + 2, 1] = X3[i];
                        Cells[i + 2, 2] = Y3[i];
                    }
                    break;

                case 3:
                    MessageBox.Show("Please pass your own data");
                    break;

                default:
                    break;
            }
        }

        private void comboBox2_SelectedIndexChanged(object sender, EventArgs e)
        {
            get_Range("S1", "T32000").ClearContents();
            get_Range("C1", "C32000").ClearContents();
            get_Range("D10", "E32000").ClearContents();
            get_Range("C1", "C32000").Interior.ColorIndex = 2;
            //switch between the 4 methods used in this example
            int ind2 = comboBox2.SelectedIndex;
            switch (ind2)
            {
                case 0:

                    break;
                case 1:

                    break;

                case 2:
                    Cells[1, 3] = "Weights";
                    get_Range("C1", "C32000").Interior.ColorIndex = 27;
                    for (int i = 0; i < Convert.ToInt32(num_of_weights.Value); i++)
                    {
                        Cells[i + 2, 3] = 1;
                    }

                    MessageBox.Show("For this method weights w[i] > 0.0, i=0,...,m-1 (length equals the number of x or y-values) have to be passed(default weights=1). Please mark for this method 3 adjacent columns in the workbook containig x-, y- and w-values.");
                    break;

                case 3:
                    Cells[1, 3] = "Weights";
                    get_Range("C1", "C32000").Interior.ColorIndex = 27;

                    for (int i = 0; i < Convert.ToInt32(num_of_weights.Value); i++)
                    {
                        Cells[i + 2, 3] = 1;
                    }

                    try
                    {

                        int int_intervl = Convert.ToInt32(num_of_weights.Value) - 3;
                        int k = Convert.ToInt32(Interaction.InputBox("Please pass the number of interior intervals ncap, which is one greater then the number of interior knots lamda.The knots are strictly within the range x[0] to x[m-1]. Default value is data_point - 3", "Degree of Polynomial", /*"Integer Value"*/ int_intervl.ToString(), 10, 10));
                        int count = Convert.ToInt32(num_of_weights.Value) - k +1;
                        Cells[10, 4] = "ncap =";
                        Cells[10, 5] = k;
                        
                        for (int i = 0; i < k - 1; i++)
                        {
                            Cells[11 + i, 4] = "knot[" + (i + 1) + "] =";
                            Cells[11 + i, 5] = Cells[count + i, 1];
                        }
                        MessageBox.Show("Before marking the area containing  the x-, y- and w-values please pass the interior knots (knot_1,...,knot_n).");
                        MessageBox.Show("For this method weights w[i] > 0.0, i=0,...,m-1 (length equals the number of x or y-values) have to be passed. Please mark for this method 3 adjacent columns containig x-, y- and w-values.");
                    }
                    catch (FormatException)
                    {
                        MessageBox.Show("You have passed the wrong format!");
                    }
                    break;

                default:
                    break;
            }
        }

        private void button1_Click(object sender, EventArgs e)
        {
        
            get_Range("S1", "V32000").ClearContents();

            try
            {
            //define the excel range to be the user selected area in the worksheet
            Excel.Range myRange = (Excel.Range)Application.ActiveWindow.Selection;

            //save values of the cells into System.Array
            System.Array Values = (System.Array)myRange.Value2;

            //Arrays for the selected x-, y-values and weights
            double[] x = new double[Values.GetUpperBound(0)];
            double[] y = new double[Values.GetUpperBound(0)];
            double[] w = new double[Values.GetUpperBound(0)];


            double[,] DoubleValues = new double[Values.GetUpperBound(0), Values.GetUpperBound(1)];

            for (int i = 0; i < Values.GetUpperBound(0); i++)
            {
                for (int j = 0; j < Values.GetUpperBound(1); j++)
                {
                    if (Values.GetValue(i + 1, j + 1) != null)
                    {
                        DoubleValues[i, j] = double.Parse(Values.GetValue(i + 1, j + 1).ToString());
                    }
                }

            }
            //save data into the arrays x and y if existent also the weights
            for (int i = 0; i < Values.GetUpperBound(0); i++)
            {
                x[i] = DoubleValues[i, 0];
                Cells[i + 1, 21] = x[i];
                y[i] = DoubleValues[i, 1];
                Cells[i + 1, 22] = y[i];
                if (comboBox2.SelectedIndex == 2 || comboBox2.SelectedIndex == 3)
                {
                    w[i] = DoubleValues[i, 2];
                }
            }

            //xarg will contain the points to be evaluated for all the routines 
            int m = Values.GetUpperBound(0);
            double[] xarg = new double[4 * m - 3];

            for (int i = 0; i < m; i++)
            {
                xarg[4 * i] = x[i];
                if (i > 0)
                {
                    xarg[4 * i - 3] = x[i - 1] + (x[i] - x[i - 1]) * 0.25;
                    xarg[4 * i - 2] = x[i - 1] + (x[i] - x[i - 1]) * 0.5;
                    xarg[4 * i - 1] = x[i - 1] + (x[i] - x[i - 1]) * 0.75;
                }
            }

            Nag_Spline spline = new Nag_Spline();
            NagError fail = new NagError();

            //define needed variables for the routines e01bac and e02bbc
            double fit = 0.0D;

            //needed variables for the routines e01bec and e01bfc
            int n = 4 * m - 3;
            double[] d = new double[m];
            double[] pf = new double[n];

              int ind2 = comboBox2.SelectedIndex;
              switch (ind2)
              {
                  //cubic spline interpolation. cubic spline is calculated by the routine e01bac and evaluated by e02bbc
                  case 0:
                      try
                      {
                          e01bac(m, x, y, ref spline, ref fail);
                          switch (fail.code)
                          {
                              case 11:
                                  throw new Exception("On entry, m < 4 or lck < m + 4 or lwrk < 6 * m + 16");
                              case 63:
                                  throw new Exception("The x-values fail to satisfy the condition x[0] < x[1] <...< x[m-1]");
                              case 0:
                                  break;

                              case 716:
                                  throw new Exception("No Licence");

                              default:
                                  throw new Exception("Internal Error?");
                          }
                      }
                      catch (Exception ex)
                      {
                          MessageBox.Show(ex.Message);
                          break;
                      }

                      //evaluate for different values
                      Cells[1, 19] = "X Values";
                      Cells[1, 20] = "Spline Values";
                      for (int i = 0; i < xarg.Length; i++)
                      {
                          try
                          {
                              e02bbc(xarg[i], ref fit, ref spline, ref fail);

                              switch (fail.code)
                              {
                                  case 11:
                                      throw new Exception("The parameter x does not satisfy lamda[4] <= x <= lamda[ncap7-3]. In this case the value of s is set arbitrarily to zero.");
                                  case 247:
                                      throw new Exception("ncap7 < 8, i.e., the number of interior knots is negative.");
                                  case 0:
                                      break;

                                  case 716:
                                      throw new Exception("No Licence");

                                  default:
                                      throw new Exception("Internal Error?");

                              }
                          }
                          catch (Exception ex)
                          {
                              MessageBox.Show(ex.Message);
                              break;
                          }


                          Cells[i + 2, 19] = xarg[i];
                          Cells[i + 2, 20] = fit;
                      }
                      break;

                  //Hermite Interpolant is calculated by the routine e01bec and evaluated by e01bfc.
                  case 1:
                      try
                      {
                          e01bec(m, x, y, d, ref fail);

                          switch (fail.code)
                          {
                              case 11:
                                  throw new Exception("On entry, n < 2.");

                              case 245:
                                  throw new Exception("The values of x[r], for r = 0,1,...,m-1, are not in strictly increasing order.");
                              case 0:
                                  break;

                              case 716:
                                  throw new Exception("No Licence");

                              default:
                                  throw new Exception("Internal Error?");
                          }

                      }
                      catch (Exception ex)
                      {
                          MessageBox.Show(ex.Message);
                          break;
                      }
                     

                      try
                      {
                          e01bfc(m, x, y, d, n, xarg, pf, ref fail);
                          switch (fail.code)
                          {
                              case 11:
                                  throw new Exception("On entry, n < 2 or m < 1.");

                              case 245:
                                  throw new Exception("The values of x[r], for r = 0,1,...,m-1, are not in strictly increasing order.");

                              case 246:
                                  throw new Exception("At least one of the points px[i], for i= 0,1,...,n-1, lies outside the interval [x[0],x[m-1]], and the extrapolation was performed at all such points. Values computed at such points may be very unreliable.");
                              case 0:
                                  break;

                              case 716:
                                  throw new Exception("No Licence");

                              default:
                                  throw new Exception("Internal Error?");
                          }
                      }
                      catch (Exception ex)
                      {
                          MessageBox.Show(ex.Message);
                          break;
                      }

                      Cells[1, 19] = "X Values";
                      Cells[1, 20] = "Interpolated Values";

                      for (int i = 0; i < n; i++)
                      {
                          Cells[i + 2, 19] = xarg[i];
                          Cells[i + 2, 20] = pf[i];
                      }
                      break;

                  //Least Squares polynomial is calculated by the e02adc and evaluated by the routine e02aec.
                  case 2:
                      int poly_degree = 2 * Convert.ToInt32(Math.Round(Math.Sqrt(m)));
                      int k = Convert.ToInt32(Interaction.InputBox("Please pass the degree of the polynomial to approximate the data points [default: 2 * Sqrt(number_of_data_points)]:", "Degree of Polynomial", /*"Integer Value"*/poly_degree.ToString(), 10, 10));
                      int kplus1 = k + 1;
                      int lda = kplus1;
                      double[,] a = new double[kplus1, kplus1];
                      double[] s = new double[kplus1];
                      double[] ak = new double[kplus1];
                      double xcap;

                      try
                      {
                          e02adc(m, kplus1, lda, x, y, w, a, s, ref fail);
                          switch (fail.code)
                          {
                              case 249:
                                  throw new Exception("The weights are not all strictly positive.");
                              case 66:
                                  throw new Exception("The values of x[r], for r = 0, 1, 2, . . . ,m-1, are not in nondecreasing order.");
                              case 67:
                                  throw new Exception("All x[r] have the same value: thus the normalization of x is not possible.");
                              case 11:
                                  throw new Exception("On entry, kplus1 < 1 (so the maximum degree required is negative) or kplus1 > mdist, where mdist is the number of distinct x values in the data (so there cannot be a unique solution for degree k = kplus1 - 1).");
                              case 17:
                                  throw new Exception("lda < kplus1.");
                              case 0:
                                  break;

                              case 716:
                                  throw new Exception("No Licence");

                              default:
                                  throw new Exception("Internal Error?");
                          }
                      }
                      catch (Exception ex)
                      {
                          MessageBox.Show(ex.Message);
                          break;
                      }

                      for (int j = 0; j <= k; j++)
                      {
                          ak[j] = a[k, j];
                      }

                      //evaluate at different points
                      Cells[1, 19] = "X Values";
                      Cells[1, 20] = "Polynomial Values";

                      for (int i = 0; i < xarg.Length; i++)
                      {
                          xcap = ((xarg[i] - xarg[0]) - (xarg[xarg.Length - 1] - xarg[i])) / (xarg[xarg.Length - 1] - xarg[0]);

                          try
                          {
                              e02aec(kplus1, ak, xcap, ref fit, ref fail);
                              switch (fail.code)
                              {
                                  case 280:
                                      throw new Exception("ABS(xcap)> 1.0 + 4*eps, where eps is the machine precision. In this case the value of p is set arbitrarily to zero");
                                  case 11:
                                      throw new Exception("On entry, nplus1 < 1.");
                                  case 0:
                                      break;

                                  case 716:
                                      throw new Exception("No Licence");

                                  default:
                                      throw new Exception("Internal Error?");
                              }
                          }
                          catch (Exception ex)
                          {
                              MessageBox.Show(ex.Message);
                              break;
                          }

                          Cells[i + 2, 19] = xarg[i];
                          Cells[i + 2, 20] = fit;

                         
                      }
                      break;

                  //Cubic spline approximation calculated by the routine e02bac and evaluated by e02bbc
                  case 3:
                      Excel.Range intKRange = this.get_Range("E10", "E32000");
                      Array knots = (Array)intKRange.Value2;
                      double[,] doubleKnots = new double[knots.GetUpperBound(0), knots.GetUpperBound(1)];

                      for (int i = 0; i < knots.GetUpperBound(0); i++)
                      {
                          for (int j = 0; j < knots.GetUpperBound(1); j++)
                          {
                              if (knots.GetValue(i + 1, j + 1) != null)
                              {
                                  doubleKnots[i, j] = double.Parse(knots.GetValue(i + 1, j + 1).ToString());
                              }
                          }
                      }
                      //define variables for the routines e02bac and e02bbc and allocate memory
                      int ncap = Convert.ToInt32(doubleKnots[0, 0]);
                      int ncap7 = ncap + 7;
                      spline.n = ncap7;
                      spline.lamda = Marshal.AllocHGlobal(ncap7 + 10000);
                      double ss = 0.0;
                      int l = 2 * m - 1;
                      double[] xx = new double[l];
                      double[] lamda1 = new double[ncap7];

                      for (int i = 0; i < ncap + 3; i++)
                      {
                          lamda1[i + 4] = doubleKnots[i + 1, 0];
                      }

                      Marshal.Copy(lamda1, 0, spline.lamda, spline.n);

                      try
                      {
                          e02bac(m, x, y, w, ref ss, ref spline, ref fail);

                          switch (fail.code)
                          {
                              case 248:
                                  throw new Exception("The knots fail to satisfy the condition x[0] < lamda[4] <= lamda[5] <=...<= lamda[ncap7-5) < x[m-1]. Thus the knots are not in correct order or are not interior to the data interval.");
                              case 249:
                                  throw new Exception("The weights are not all strictly positive.");
                              case 62:
                                  throw new Exception("The values of x[r], for r = 0, 1, 2, ..., m - 1, are not in nondecreasing order.");
                              case 11:
                                  throw new Exception("ncap7 < 8 (so the number of interior knots is negative) or ncap7 > mdist + 4, where mdist is the number of distinct x values in the data (so there cannot be a unique solution).");
                              case 250:
                                  throw new Exception("The conditions specified by Schoenberg and Whitney (1953) fail to hold for at least one subset of the distinct data abscissae. That is, there is no subset of ncap7 - 4 strictly increasing values, x[R[0]-1],..., x[R[ncap7-5]-1], among the abscissae such that, x[R[0]-1] < lamda[0] < x[R[4]-1], x[R[1]-1] < lamda[1] < x[R[5]-1],...,x[R(ncap7-9]-1] < lamda[ncap7-9] < lamda[R[ncap7-5]-1]");
                              case 0:
                                  break;

                              case 716:
                                  throw new Exception("No Licence");

                              default:
                                  throw new Exception("Internal Error?");
                          }
                      }
                      catch (AccessViolationException)
                      {
                          MessageBox.Show("Used Memory");
                          break;
                      }
                      catch (Exception ex)
                      {
                          MessageBox.Show(ex.Message);
                          break;
                      }

                      Cells[1, 19] = "X Values";
                      Cells[1, 20] = "Approximated Spline Values";
                      for (int i = 0; i < xarg.Length; i++)
                      {
                          try
                          {
                              e02bbc(xarg[i], ref fit, ref spline, ref fail);
                              switch (fail.code)
                              {
                                  case 11:
                                      throw new Exception("The parameter x does not satisfy lamda[4] <= x <= lamda(ncap7-3). In this case the value of S is set arbitrarily to zero.");
                                  case 247:
                                      throw new Exception("ncap7 < 8, i.e., the number of interior knots is negative.");
                                  case 0:
                                      break;

                                  case 716:
                                      throw new Exception("No Licence");

                                  default:
                                      throw new Exception("Internal Error?");
                              }

                          }
                          catch (Exception ex)
                          {
                              MessageBox.Show(ex.Message);
                              break;
                          }

                          Cells[i + 2, 19] = xarg[i];
                          Cells[i + 2, 20] = fit;
                      }
                       Marshal.FreeHGlobal(spline.lamda);
                      break;

                  default:
                      MessageBox.Show("Please choose a Method.");
                      break;
              }
              
            }
            catch (NullReferenceException)
            {
                MessageBox.Show("Please select with the mouse the area containing the x- and y-values (for methods 3 and 4 also weights). Two (or three) adjacent columns in the workbook");
            }
            catch (IndexOutOfRangeException)
            {
                MessageBox.Show("Missing x-Values or y-Values (for the 3th and 4th method missing also w-Values). Please mark the area with the mouse containing x and y (and w)- two (or three) adjacent columns in the workbook. ");
            }
            catch (FormatException)
            {
                MessageBox.Show("The values you have chosen are not in the right format.");
            }
            catch (InvalidCastException)
            {
                MessageBox.Show("Please mark the area with the mouse containing x and y- two adjacent columns in the workbook. ");
            }
        }

    }
}
